//#######################################################

Lib.Useful = (function() {
    var obj = {};

    function REPO() {
        this.objects = [];
    }

    REPO.prototype.addObj = function(context) {

        this.objects.push(context);

        // p("new array length is " + this.objects.length);
    }

    REPO.prototype.removeObj = function(context) {
        var index = this.objects.indexOf(context);
        this.objects.splice(index, 1);

        // p("new array length is " + this.objects.length);
    }



    REPO.prototype._update = function() {

        if (this.objects === undefined)
            return;

        for (a = 0; a < this.objects.length; a++) {
            if (this.objects[a] !== undefined && this.objects[a]._update !== undefined)
                this.objects[a]._update();
            else {
                // console.warn("TRYING TO UPDATE UNDEFINED ARRAY ELEMENT OR UPADET IS UNDEFINED");
            }
        }
    }

    obj.Repo = REPO;


    function CallbackHolder() {

        //private object 
        function CallbackObj(callback, context, argsArray) {
            this.callback = callback;
            this.context = context;
            this.argsArray = argsArray;
        }

        //Vars
        var callbacks = [];

        this.add = function(callback, context, argsArray) {
            callbacks.push(new CallbackObj(callback, context, argsArray));
        }

        this.remove = function(callback) {
            for (i = callbacks.length - 1; i >= 0; i--) {
                if (callbacks[i].callback === callback) {
                    callbacks.splice(i, 1);
                }
            }
        }

        this.removeAll = function(){
            callbacks.length=0;
        }

        this.executeCallbacks = function() {
            for (var a = 0; a < callbacks.length; a++) {
                var c = callbacks[a];

                c.callback.apply(c.context,c.argsArray);
            }
        }
    }

    obj.CallbackHolder = CallbackHolder;


    return obj;
}());
